/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TDmTabledef.TDmTabledefPath;
import de.ship.db.tables.TDmTablegrp.TDmTablegrpPath;
import de.ship.db.tables.records.TDmTablegrpdetailRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TDmTablegrpdetail extends TableImpl<TDmTablegrpdetailRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_dm_tablegrpdetail</code>
     */
    public static final TDmTablegrpdetail T_DM_TABLEGRPDETAIL = new TDmTablegrpdetail();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TDmTablegrpdetailRecord> getRecordType() {
        return TDmTablegrpdetailRecord.class;
    }

    /**
     * The column <code>common_dd.t_dm_tablegrpdetail.lastchange</code>.
     */
    public final TableField<TDmTablegrpdetailRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_dm_tablegrpdetail.pk</code>.
     */
    public final TableField<TDmTablegrpdetailRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_dm_tablegrpdetail.fk_table_grp</code>.
     * foreign key to examination/table group
     */
    public final TableField<TDmTablegrpdetailRecord, Integer> FK_TABLE_GRP = createField(DSL.name("fk_table_grp"), SQLDataType.INTEGER.nullable(false), this, "foreign key to examination/table group");

    /**
     * The column <code>common_dd.t_dm_tablegrpdetail.fk_tabledef</code>.
     * foreign key to primary key of single tables in T_DM_TABLEDEF
     */
    public final TableField<TDmTablegrpdetailRecord, Integer> FK_TABLEDEF = createField(DSL.name("fk_tabledef"), SQLDataType.INTEGER.nullable(false), this, "foreign key to primary key of single tables in T_DM_TABLEDEF");

    /**
     * The column <code>common_dd.t_dm_tablegrpdetail.table_order</code>. table
     * order
     */
    public final TableField<TDmTablegrpdetailRecord, Integer> TABLE_ORDER = createField(DSL.name("table_order"), SQLDataType.INTEGER, this, "table order");

    private TDmTablegrpdetail(Name alias, Table<TDmTablegrpdetailRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TDmTablegrpdetail(Name alias, Table<TDmTablegrpdetailRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_dm_tablegrpdetail</code> table
     * reference
     */
    public TDmTablegrpdetail(String alias) {
        this(DSL.name(alias), T_DM_TABLEGRPDETAIL);
    }

    /**
     * Create an aliased <code>common_dd.t_dm_tablegrpdetail</code> table
     * reference
     */
    public TDmTablegrpdetail(Name alias) {
        this(alias, T_DM_TABLEGRPDETAIL);
    }

    /**
     * Create a <code>common_dd.t_dm_tablegrpdetail</code> table reference
     */
    public TDmTablegrpdetail() {
        this(DSL.name("t_dm_tablegrpdetail"), null);
    }

    public <O extends Record> TDmTablegrpdetail(Table<O> path, ForeignKey<O, TDmTablegrpdetailRecord> childPath, InverseForeignKey<O, TDmTablegrpdetailRecord> parentPath) {
        super(path, childPath, parentPath, T_DM_TABLEGRPDETAIL);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TDmTablegrpdetailPath extends TDmTablegrpdetail implements Path<TDmTablegrpdetailRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TDmTablegrpdetailPath(Table<O> path, ForeignKey<O, TDmTablegrpdetailRecord> childPath, InverseForeignKey<O, TDmTablegrpdetailRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TDmTablegrpdetailPath(Name alias, Table<TDmTablegrpdetailRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TDmTablegrpdetailPath as(String alias) {
            return new TDmTablegrpdetailPath(DSL.name(alias), this);
        }

        @Override
        public TDmTablegrpdetailPath as(Name alias) {
            return new TDmTablegrpdetailPath(alias, this);
        }

        @Override
        public TDmTablegrpdetailPath as(Table<?> alias) {
            return new TDmTablegrpdetailPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TDmTablegrpdetailRecord, Integer> getIdentity() {
        return (Identity<TDmTablegrpdetailRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TDmTablegrpdetailRecord> getPrimaryKey() {
        return Keys.PK_DM_TABLEGRPDETAIL;
    }

    @Override
    public List<ForeignKey<TDmTablegrpdetailRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_DM_TABLEGRPDETAIL__FK_TABLEGRPDETAIL_TABLEGRP, Keys.T_DM_TABLEGRPDETAIL__FK_TABLEGRPDETAIL_TABLEDEF);
    }

    private transient TDmTablegrpPath _tDmTablegrp;

    /**
     * Get the implicit join path to the <code>common_dd.t_dm_tablegrp</code>
     * table.
     */
    public TDmTablegrpPath tDmTablegrp() {
        if (_tDmTablegrp == null)
            _tDmTablegrp = new TDmTablegrpPath(this, Keys.T_DM_TABLEGRPDETAIL__FK_TABLEGRPDETAIL_TABLEGRP, null);

        return _tDmTablegrp;
    }

    private transient TDmTabledefPath _tDmTabledef;

    /**
     * Get the implicit join path to the <code>common_dd.t_dm_tabledef</code>
     * table.
     */
    public TDmTabledefPath tDmTabledef() {
        if (_tDmTabledef == null)
            _tDmTabledef = new TDmTabledefPath(this, Keys.T_DM_TABLEGRPDETAIL__FK_TABLEGRPDETAIL_TABLEDEF, null);

        return _tDmTabledef;
    }

    @Override
    public TDmTablegrpdetail as(String alias) {
        return new TDmTablegrpdetail(DSL.name(alias), this);
    }

    @Override
    public TDmTablegrpdetail as(Name alias) {
        return new TDmTablegrpdetail(alias, this);
    }

    @Override
    public TDmTablegrpdetail as(Table<?> alias) {
        return new TDmTablegrpdetail(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmTablegrpdetail rename(String name) {
        return new TDmTablegrpdetail(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmTablegrpdetail rename(Name name) {
        return new TDmTablegrpdetail(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmTablegrpdetail rename(Table<?> name) {
        return new TDmTablegrpdetail(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTablegrpdetail where(Condition condition) {
        return new TDmTablegrpdetail(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTablegrpdetail where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTablegrpdetail where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTablegrpdetail where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmTablegrpdetail where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmTablegrpdetail where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmTablegrpdetail where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmTablegrpdetail where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTablegrpdetail whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTablegrpdetail whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
